#include <stdio.h>
#include "youbin.h"

int get6bit(int data);
void put6bit(char *buffer, int pos, int data);

void mimedecode( source, dest )
char *source, *dest;
{
    int   pos, data;
    char *byte_pos;

    for( pos = 0; ( data = get6bit( *source )) < 64; source++, pos += 6 ){
	    put6bit( dest, pos, data );
    }
    byte_pos = dest + ( (pos-6) / 8 ) + 1;
    *byte_pos = '\0';
}

void	put6bit( buffer, pos, data )
char *buffer;
int  pos, data;
{
    char *byte_pos;
    int  bit_pos;

    byte_pos = buffer + ( pos / 8 );
    bit_pos = pos % 8;
    data &= 0x3f;		     /* Mask 6 bits */
    if( bit_pos > 2 ) {
	*byte_pos &= ~( 0x3f >> ( bit_pos - 2 ));
	*byte_pos++ |= data >> ( bit_pos - 2 );
    }
    *byte_pos &= ~( 0x3f << (( 10 - bit_pos ) % 8 ));
    *byte_pos |= data << (( 10 - bit_pos ) % 8 );
}

int get6bit( data )
    int data;
{
    static char *base64 =
    "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
    char   *pos;

    return (pos = index( base64, data ))== NULL ? 64 : pos - base64;
}
